;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; 02_co.lisp - Paralelní scheme
;;;


;; Procedura process-run-procedure
(execute '(:swap (:clsub :quit) :cons :prsub  nil :ret) 'process-run-procedure :bind)

;; Speciální operátor await
(execute 'await 'specials :val :cons 'specials :set!)
(execute '((eval :val :clsub :ret) append :val :clsub :await nil :ret) 'await :bind)

#|
;; Scheme 
(let ((end? nil))
  (process-run-procedure (lambda (a)
                          (print a)
                          (set! end? t))
                        1)
  (await end?))


|#

;; Makro co
(evaluate '(defmac co (lambda (args)
                        (if args
                            (let ((endp (gensym "ENDP"))
                                  (arg (gensym "ARG")))
                              (list 'let (list (list endp nil))
                                    (list 'process-run-procedure 
                                          (list 'lambda (list arg)
                                                (first args)
                                                (list 'set! endp t))
                                          nil)
                                    (cons 'co (cdr args))
                                    (list 'await endp)))
                          nil))))                     
                                            
 #|
(let ((n 0))
  (co
   (let ((tmp nil))
     (set! tmp (+ n 1))
     (set! n tmp))
   (let ((tmp nil))
     (set! tmp (+ n 1))
     (set! n tmp)))
  n)
|#   

;; Závěrečný test
#|
;; Scheme

;; Jaké hodnoty může výraz vrátit?
(let ((n 0))
  (co
   (dotimes (i 100)
     (set! n (+ n 1)))
   (dotimes (i 100)
     (set! n (+ n 1))))
  n)

;; Přepsáno na atomické příkazy:
(let ((n 0))
  (co
   (let ((tmp nil))
     (dotimes (i 100)
       (set! tmp (+ n 1)) 
       (set! n tmp)))
   (let ((tmp nil))
     (dotimes (i 100)
       (set! tmp (+ n 1)) 
       (set! n tmp))))
  n)
|#                     